close all; clear all; clc;
[fname,pname] = uigetfile('*.grd','input of data (ESRI ASCII *.grid file)');
fid = fopen(fname,'r');
%reading of the ESRI ASCII grid header (ncols, nrows, xllcorner, yllcorner, cellsize, nodata_value)
row1 = fgetl(fid); [token,rem] = strtok(row1); ncols = str2double(rem)
row2 = fgetl(fid); [token,rem] = strtok(row2); nrows = str2double(rem)
row3 = fgetl(fid); [token,rem] = strtok(row3); xllcorner = str2double(rem)
row4 = fgetl(fid); [token,rem] = strtok(row4); yllcorner = str2double(rem)
row5 = fgetl(fid); [token,rem] = strtok(row5); cellsize = str2double(rem)
row6 = fgetl(fid); [token,rem] = strtok(row6); nodata_value = str2double(rem)
%reading of the ESRI ASCII grid data
[A,count] = fscanf(fid,'%f',[ncols,nrows]); %fscanf() works in column order - columns and rows are switched
field = flipud(A'); %readed matrix A must be transponed because function fscanf() works in column order,
                    % and fliiped up and down, because ESRI starts with rows in upper left corner 
status = fclose(fid);
%generating the x_cor and y_cor vectors
x_cor = xllcorner:cellsize:(ncols-1)*cellsize+xllcorner;
y_cor = yllcorner:cellsize:(nrows-1)*cellsize+yllcorner;
%plotting the contourf() map
figure, contourf(x_cor,y_cor,field)
%information for the user
s = [' size of readed grid: ' int2str(nrows) ' rows x ' int2str(ncols) ' columns'];
msgbox(s,'message');
